C	*********************************************************
C	MAINMENU TO SELECT KIND OF TREATMENT OF GIVEN DATA
C	*********************************************************
C	***********************************************************
C	DIALOG-ROUTINES TO INPUT GRAIN- AND SURROUNDING PARAMETERS
C	***********************************************************
	PROGRAM MAIN
	CHARACTER YN

10	FORMAT (////////////////////////////////////////)
11	FORMAT (12X,' ---------------------------------------------')
15	FORMAT (12X,' |          MIE SCATTERING PROGRAM           |')
16	FORMAT (12X,' |                                           |')
17	FORMAT (12X,' |           Reduced Version 3.0             |')
18	FORMAT (12X,' | V.Ossenkopf - University Observatory Jena |')
19	FORMAT (12X,' ---------------------------------------------',//)
12	FORMAT (/,/,'  CONTINUE ? ',$)
13	FORMAT (A1)
200	WRITE (6,10)
	WRITE (6,11)
	WRITE (6,15)
	WRITE (6,16)
	WRITE (6,17)
	WRITE (6,18)
	WRITE (6,19)
130	CALL SCAFN
	WRITE(6,12)
	READ(5,13) YN
	IF (YN.EQ.'Y'.OR.YN.EQ.'y') GOTO 200
250	END

C	***********************************************************
C	SCAFN CALCULATES ABSORPTION AND SCATTERING EFFICIENCIES
C	FROM REFRACTIVE INDICEES, RELATIVE PERMEABILITIES
C	AND THE SIZE PARAMETER OF THE GRAIN
C	SCAFN USES BHMIE
C	***********************************************************
	SUBROUTINE SCAFN
	COMPLEX REFREL,MUEREL
	REAL FWL(256),FN(256),FK(256),FMU(256),FMI(256),FQA(256),
     %  FQS(256),FG(256)
	REAL REFMED,MUEMED,RAD,QEXT,QSCA,G,Z,X,SPX
	INTEGER M,NN
	CHARACTER*40 LFILE(3)
	CHARACTER*10 DUMMY
	COMMON /PHYS/ REFMED,MUEMED,RAD

	CALL PHYSPAR
	CALL READMUFILE(FWL,FN,FK,FMU,FMI,M,DUMMY)
	CALL NAMEREAD(LFILE)
C	***********************************************************
C	CALCULATION OF REFRACTIVE INDEX DEPENDENT FROM WAVELENGTH
C	***********************************************************
	DO 220 NN=1,M
	Z=1./FWL(NN)
	REFREL=CMPLX(FN(NN),FK(NN))/REFMED
	MUEREL=CSQRT(CMPLX(FMU(NN),FMI(NN))/MUEMED)
	X=SPX(Z)
C	IF (X.GT.1000.0) X=1000.0
26	FORMAT (/,' WAVELENGTH = ',G12.5,'  Z = ',G12.5,
     %'  SIZE PARAMETER =',G12.5,/,' N          =',G12.5,
     %' K =',G12.5,' MUE` =',G12.5,' MUE`` =',G12.5)
	WRITE (6,26) FWL(NN),Z,X,FN(NN),FK(NN),FMU(NN),FMI(NN)

C	***********************************************************
C	CALCULATION OF SCATTERING MATRIX ELEMENTS BY BHMIE
C	***********************************************************
	CALL MIEMUE(X,REFREL,MUEREL,QEXT,QSCA,G)
	FQA(NN)=QEXT-QSCA
	FQS(NN)=QSCA
	FG(NN)=G
29	FORMAT (' QABS = ',E12.5,' QSCA = ',E12.5,' QEXT = ',E12.5,
     % ' G = ',E11.4)
	WRITE (6,29) FQA(NN),FQS(NN),QEXT,FG(NN)
220	CONTINUE
	CALL QAWRITE(FWL,FQA,M,LFILE(1))
	CALL QAWRITE(FWL,FQS,M,LFILE(2))
	CALL QAWRITE(FWL,FG,M,LFILE(3))
	END

C	***********************************************************
C	SIZE PARAMETER X
C	***********************************************************
	REAL FUNCTION SPX(Z)
	REAL REFMED,MUEMED,RAD
	REAL Z,PI
	COMMON /PHYS/ REFMED,MUEMED,RAD
	DATA PI /3.141592/

	SPX=2.*PI*RAD*REFMED*SQRT(MUEMED)*Z
	RETURN
	END

C	********************************************************
C	SUBROUTINE MIEMUE CALCULATES EFFICIENCIES FOR 
C	EXTINCTION AND TOTAL SCATTERING AND THE AVERAGE ASYMMETRY
C	FACTOR FOR A GIVEN SIZE PARAMETER,
C	RELATIVE REFRACTIVE INDEX, AND RELATIVE PERMEABILITY
C	********************************************************
	SUBROUTINE MIEMUE(X,REFREL,MUEREL,QEXT,QSCA,ASYM)
	real x,qext,qsca,asym
	REAL PI,PIF,FN,xstop,ymod,rn
	real chi0,chi1,chi,apsi0,apsi1,apsi
	COMPLEX D(3000),Y,REFREL,MUEREL
	complex XI,XI0,XI1,AN,BN,HN,ANO,BNO,BNH,S1,G
	DOUBLE PRECISION PSI0,PSI1,PSI,DN,DX
	integer nstop,nmx,n,nn
200	DX=X
	Y=X*REFREL*MUEREL
C	********************************************************
C	SERIES TERMINATED AFTER NSTOP TERMS
C	********************************************************
	XSTOP=X+4.*X**.33333+2.0
	NSTOP=XSTOP
	YMOD=CABS(Y)
	NMX=AMAX1(XSTOP,YMOD)+15
C	********************************************************
C	EXCEPTION HANDLING FOR VERY LARGE X
C	********************************************************
	IF (NMX.GT.3000) THEN
	X=X*2900.0/REAL(NMX)
	GOTO 200
	ENDIF
C	********************************************************
C	LOGARITHMIC  DERIVATIVE D(J) CALCULATED BY DOWNWARD
C	RECURRENCE BEGINNING WITH INITIAL VALUE 0.0 + I*0.0
C	AT J = NMX
C	********************************************************
	D(NMX)=CMPLX(0.0,0.0)
	NN=NMX-1
	DO 210 N=1,NN
	RN=NMX-N+1
210	D(NMX-N)=(RN/Y)-(1./(D(NMX-N+1)+RN/Y))
	S1=CMPLX(0.0,0.0)
C	********************************************************
C	RICCATI-BESSEL FUNCTIONS WITH REAL ARGUMENT X
C	CALCULATED BY UPWARD RECURRENCE
C	********************************************************
	PSI0=DCOS(DX)
	PSI1=DSIN(DX)
	CHI0=-SIN(X)
	CHI1=COS(X)
	APSI0=PSI0
	APSI1=PSI1
	XI0=CMPLX(APSI0,-CHI0)
	XI1=CMPLX(APSI1,-CHI1)
	QSCA=0.0
	G=CMPLX(0.0,0.0)
	ANO=G
	BNO=G
	N=1
250	DN=N
	RN=N
	PI=RN*(RN+1.)*0.5
	PIF=(RN-1.)*(RN+1.)/RN
	FN=(2.*RN+1.)/(RN*(RN+1.))
	PSI=(2.*DN-1.)*PSI1/DX-PSI0
	APSI=PSI
	CHI=(2.*RN-1.)*CHI1/DX-CHI0
	XI=CMPLX(APSI,-CHI)
	HN=D(N)*MUEREL/REFREL+RN/X
	AN=(HN*APSI-APSI1)/(HN*XI-XI1)
	HN=D(N)*REFREL/MUEREL+RN/X
	BN=(HN*APSI-APSI1)/(HN*XI-XI1)
	QSCA=QSCA+(2.*RN+1.)*(CABS(AN)**2+CABS(BN)**2)
	S1=S1+FN*(AN*PI+BN*PI)
	BNH=CONJG(BN)
	G=G+((RN+0.5)/PI)*AN*BNH+PIF*(ANO*CONJG(AN)+BNO*BNH)
	ANO=AN
	BNO=BN
	PSI0=PSI1
	PSI1=PSI
	APSI1=PSI1
	CHI0=CHI1
	CHI1=CHI
	XI1=CMPLX(APSI1,-CHI1)
	N=N+1
	RN=N
	IF(N-1.LT.NSTOP) GOTO 250
	ASYM=2.*REAL(G)/QSCA
	QSCA=(2./(X*X))*QSCA
	QEXT=(4./(X*X))*REAL(S1)
	RETURN
	END

